<?php
/*
Plugin Name: Top Level Categories
Plugin URI: http://fortes.com/projects/wordpress/toplevelcategories/
Description: Removes the prefix from the URL for a category. For instance, if your old category link was <code>/category/catname</code> it will now be <code>/catname</code>
Version: 0.1
Author: Filipe Fortes
Author URI: http://fortes.com/  

Known issues:
 - This plugin will NOT work if you are using /%postname%/ as your
   permalink structure for posts
*/

// In case we're running standalone, for some odd reason
if (function_exists('add_action'))
{
	//add_filter('rewrite_rules_array', 'fortes_rewrites');
	global $new_rewrites;
	$new_rewrites = array();
	add_filter('category_rewrite_rules', 'fortes_category_rewrite_rules');
	add_filter('rewrite_rules_array', 'fortes_rewrite_rules_array');
	add_filter('category_link', 'fortes_categorylink', 10, 2);
}

function fortes_categorylink($cat_link, $cat_id)
{
	return fortes_remove_cat_base($cat_link);
}

function fortes_rewrite_rules_array($rules)
{
	global $new_rewrites;
	return $rules + $new_rewrites;
}

function fortes_category_rewrite_rules($category_rewrite)
{
	global $new_rewrites;

	while (list($k, $v) = each($category_rewrite)) {
		$new_rewrites[fortes_remove_cat_base($k)] = $v;
	}
	
	return array();
}

function fortes_remove_cat_base($link)
{
	$category_base = get_option('category_base');
	if ($category_base == '') 
		$category_base = 'category';
	if (substr($category_base, 0, 1) == '/')
		$category_base = substr($category_base, 1);
	
	$category_base .= '/';
  return str_replace($category_base, '',$link);
}
?>
